﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NavisionApp.NAVService;
using System.ServiceModel;

namespace NavisionApp
{
    public class NAVItem
    {
        public string ItemNo { get; set; }
        public string ItemDesc { get; set; }
        public string BaseUOM { get; set; }
        public string ItemCatCode { get; set; }
        public string QtyonSales { get; set; }
        public string QtyonPurch { get; set; }
        public string UnitCost { get; set; }
        public string UnitPrice { get; set; }
        public string LastDirectCost { get; set; }
        public string Availability { get; set; }
    }

    

    public class GetItems
    {
        WebServiceHelper webServiceHelper = new WebServiceHelper();

        public List<NAVItem> LoadItems()
        {
            try
            {
                string baseURL = "http://localhost:7047/DynamicsNAV70/WS/CRONUS USA, Inc./Page/ItemCard";

                ItemCard_PortClient ItemCardService = new ItemCard_PortClient(webServiceHelper.GetNAVBinding(), new EndpointAddress(baseURL));

                ItemCardService.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Delegation;
                ItemCardService.ClientCredentials.Windows.ClientCredential.UserName = "win8user";
                ItemCardService.ClientCredentials.Windows.ClientCredential.Password = "win8win8";
                ItemCardService.ClientCredentials.Windows.ClientCredential.Domain = "WIN8RTM";


                const int fetchsize = 30;

                Task<ReadMultiple_Result1> _itemResult = ItemCardService.ReadMultipleAsync(new ItemCard_Filter[] { }, null, fetchsize);
                ReadMultiple_Result1 itemResults = _itemResult.Result;

                List<NAVItem> NAVItems = new List<NAVItem>();

                foreach (ItemCard t in itemResults.ReadMultiple_Result)
                {
                    NAVItem navItem = new NAVItem();
                    navItem.ItemNo = t.No;
                    navItem.ItemDesc = t.Description;
                    navItem.ItemCatCode = t.Item_Category_Code;
                    navItem.BaseUOM = t.Base_Unit_of_Measure;
                    navItem.QtyonPurch = string.Format("{0}", System.Convert.ToDecimal(t.Qty_on_Purch_Order));
                    navItem.QtyonSales = string.Format("{0}", System.Convert.ToDecimal(t.Qty_on_Sales_Order));
                    navItem.UnitCost = string.Format("{0:C}", System.Convert.ToDecimal(t.Unit_Cost));
                    navItem.UnitPrice = string.Format("{0:C}", System.Convert.ToDecimal(t.Unit_Price));
                    navItem.LastDirectCost = string.Format("{0:C}", System.Convert.ToDecimal(t.Last_Direct_Cost));
                    navItem.Availability = string.Format("{0}", System.Convert.ToDecimal(t.Inventory));

                    NAVItems.Add(navItem);
                }

                return NAVItems;
            }
            catch (Exception)
            {
                
                throw;
            }
            
        }
        
        public List<NAVItem> SearchItem(string searchString)
        {
            try
            {
                string baseURL = "http://localhost:7047/DynamicsNAV70/WS/CRONUS USA, Inc./Page/ItemCard";

                ItemCard_PortClient ItemCardService = new ItemCard_PortClient(webServiceHelper.GetNAVBinding(), new EndpointAddress(baseURL));

                ItemCardService.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Delegation;
                ItemCardService.ClientCredentials.Windows.ClientCredential.UserName = "win8user";
                ItemCardService.ClientCredentials.Windows.ClientCredential.Password = "win8win8";
                ItemCardService.ClientCredentials.Windows.ClientCredential.Domain = "WIN8RTM";


                const int fetchsize = 100;
                ItemCard_Filter filter1 = new ItemCard_Filter();
                filter1.Field = ItemCard_Fields.Description;
                filter1.Criteria = "@*" + searchString + "*";

                ItemCard_Filter[] filters = new ItemCard_Filter[] { filter1 };

                Task<ReadMultiple_Result1> _itemResult = ItemCardService.ReadMultipleAsync(filters, null, fetchsize);
                ReadMultiple_Result1 itemResults = _itemResult.Result;

                List<NAVItem> NAVItems = new List<NAVItem>();

                foreach (ItemCard t in itemResults.ReadMultiple_Result)
                {
                    NAVItem navItem = new NAVItem();
                    navItem.ItemNo = t.No;
                    navItem.ItemDesc = t.Description;
                    navItem.ItemCatCode = t.Item_Category_Code;
                    navItem.BaseUOM = t.Base_Unit_of_Measure;
                    navItem.QtyonPurch = string.Format("{0}", System.Convert.ToDecimal(t.Qty_on_Purch_Order));
                    navItem.QtyonSales = string.Format("{0}", System.Convert.ToDecimal(t.Qty_on_Sales_Order));
                    navItem.UnitCost = string.Format("{0:C}", System.Convert.ToDecimal(t.Unit_Cost));
                    navItem.UnitPrice = string.Format("{0:C}", System.Convert.ToDecimal(t.Unit_Price));
                    navItem.LastDirectCost = string.Format("{0:C}", System.Convert.ToDecimal(t.Last_Direct_Cost));
                    navItem.Availability = string.Format("{0}", System.Convert.ToDecimal(t.Inventory));

                    NAVItems.Add(navItem);
                }

                return NAVItems;
            }
            catch (Exception)
            {
                
                throw;
            }
            
            
        }
        
    }
}
