﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NavisionApp.NAVService;
using System.ServiceModel;

namespace NavisionApp
{
    
    public class NAVVendor
    {
        public string vendorNo { get; set; }
        public string vendorName { get; set; }
        public string vendAddr { get; set; }
        public string vendAddr2 { get; set; }
        public string vendCity { get; set; }
        public string vendState { get; set; }
        public string vendZipcode { get; set; }
        public string vendCountry { get; set; }
        public string vendPhoneNo { get; set; }
        public string vendBalance { get; set; }
        public string vendNoOfOrders { get; set; }
    }

    

    public class GetVendors
    {
        WebServiceHelper webServiceHelper = new WebServiceHelper();

        public List<NAVVendor> LoadVendors()
        {
            try
            {
                string baseURL = "http://localhost:7047/DynamicsNAV70/WS/CRONUS USA, Inc./Page/VendorCard";

                VendorCard_PortClient VendorCardService = new VendorCard_PortClient(webServiceHelper.GetNAVBinding(), new EndpointAddress(baseURL));

                VendorCardService.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Delegation;
                VendorCardService.ClientCredentials.Windows.ClientCredential.UserName = "win8user";
                VendorCardService.ClientCredentials.Windows.ClientCredential.Password = "win8win8";
                VendorCardService.ClientCredentials.Windows.ClientCredential.Domain = "WIN8RTM";


                const int fetchsize = 30;

                Task<ReadMultiple_Result2> _vendorResult = VendorCardService.ReadMultipleAsync(new VendorCard_Filter[] { }, null, fetchsize);
                ReadMultiple_Result2 vendorResults = _vendorResult.Result;

                List<NAVVendor> NAVVendors = new List<NAVVendor>();

                foreach (VendorCard v in vendorResults.ReadMultiple_Result)
                {
                    NAVVendor navVendor = new NAVVendor();
                    navVendor.vendorNo = v.No;
                    navVendor.vendorName = v.Name;
                    navVendor.vendAddr = v.Address;
                    navVendor.vendAddr2 = v.Address_2;
                    navVendor.vendCity = v.City;
                    navVendor.vendState = v.County;
                    navVendor.vendCountry = v.Country_Region_Code;
                    navVendor.vendBalance = string.Format("{0:C}", System.Convert.ToDecimal(v.Purchaser_Code));
                    navVendor.vendNoOfOrders = v.Purchaser_Code;

                    NAVVendors.Add(navVendor);
                }

                return NAVVendors;
            }
            catch (Exception)
            {
                
                throw;
            }
            
        }

        public List<NAVVendor> SearchVendor(string searchString)
        {
            try
            {
                string baseURL = "http://localhost:7047/DynamicsNAV70/WS/CRONUS USA, Inc./Page/VendorCard";

                VendorCard_PortClient VendorCardService = new VendorCard_PortClient(webServiceHelper.GetNAVBinding(), new EndpointAddress(baseURL));

                VendorCardService.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Delegation;
                VendorCardService.ClientCredentials.Windows.ClientCredential.UserName = "win8user";
                VendorCardService.ClientCredentials.Windows.ClientCredential.Password = "win8win8";
                VendorCardService.ClientCredentials.Windows.ClientCredential.Domain = "WIN8RTM";

                VendorCard_Filter filter1 = new VendorCard_Filter();
                filter1.Field = VendorCard_Fields.Name;
                filter1.Criteria = "@*" + searchString + "*";

                VendorCard_Filter[] filters = new VendorCard_Filter[] { filter1 };

                const int fetchsize = 30;

                Task<ReadMultiple_Result2> _vendorResult = VendorCardService.ReadMultipleAsync(filters, null, fetchsize);
                ReadMultiple_Result2 vendorResults = _vendorResult.Result;

                List<NAVVendor> NAVVendors = new List<NAVVendor>();

                foreach (VendorCard v in vendorResults.ReadMultiple_Result)
                {
                    NAVVendor navVendor = new NAVVendor();
                    navVendor.vendorNo = v.No;
                    navVendor.vendorName = v.Name;
                    navVendor.vendAddr = v.Address;
                    navVendor.vendAddr2 = v.Address_2;
                    navVendor.vendCity = v.City;
                    navVendor.vendState = v.County;
                    navVendor.vendCountry = v.Country_Region_Code;
                    navVendor.vendBalance = string.Format("{0:C}", System.Convert.ToDecimal(v.Balance_LCY));
                    navVendor.vendNoOfOrders = string.Format("{0}", System.Convert.ToDecimal(v.No_of_Orders));

                    NAVVendors.Add(navVendor);
                }

                return NAVVendors;
            }
            catch (Exception)
            {
                
                throw;
            }
                              
            
        }
    }
}
