﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NavisionApp.NAVService;
using System.ServiceModel;

namespace NavisionApp
{
    public class SalesHeader
    {
        public string orderNo { get; set; }
        public string custNo { get; set; }
        public string custName { get; set; }
        public string custAddr { get; set; }
        public string custAddr2 { get; set; }
        public string custCity { get; set; }
        public string custState { get; set; }
        public string custZipcode { get; set; }
        public string custCountry { get; set; }
        public string custContactNo { get; set; }
        public string orderDate { get; set; }
        public string orderAmt { get; set; }
        public string shipmentAgent { get; set; }
        public string shipmentService { get; set; }
        public string payTerms { get; set; }
        public string status { get; set; }
    }

    public class SalesLine
    {
        public string itemNo { get; set; }
        public string itemDesc { get; set; }
        public string Qty { get; set; }
        public string unitPrice { get; set; }
        public string shipDate { get; set; }
        public string planShipDate { get; set; }
        public string lineAmt { get; set; }
        public string qtyToShip { get; set; }
        public string qtyToInvoice { get; set; }
    }

    public class GetSales
    {
        WebServiceHelper webServiceHelper = new WebServiceHelper();

        public List<SalesHeader> LoadSales()
        {
            try
            {
                string baseURL = "http://localhost:7047/DynamicsNAV70/WS/CRONUS USA, Inc./Page/SalesOrder";


                SalesOrder_PortClient salesOrderService = new SalesOrder_PortClient(webServiceHelper.GetNAVBinding(), new EndpointAddress(baseURL));

                salesOrderService.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Delegation;
                salesOrderService.ClientCredentials.Windows.ClientCredential.UserName = "win8user";
                salesOrderService.ClientCredentials.Windows.ClientCredential.Password = "win8win8";
                salesOrderService.ClientCredentials.Windows.ClientCredential.Domain = "WIN8RTM";


                const int fetchsize = 30;

                Task<ReadMultiple_Result4> _salesResult = salesOrderService.ReadMultipleAsync(new SalesOrder_Filter[] { }, null, fetchsize);
                ReadMultiple_Result4 salesResults = _salesResult.Result;

                List<SalesHeader> navSales = new List<SalesHeader>();
                List<SalesLine> navSalesLines = new List<SalesLine>();

                foreach (SalesOrder so in salesResults.ReadMultiple_Result)
                {
                    SalesHeader navSale = new SalesHeader();
                    navSale.orderNo = so.No;
                    navSale.custNo = so.Sell_to_Customer_No;
                    navSale.custName = so.Sell_to_Customer_Name;
                    navSale.custAddr = so.Sell_to_Address;
                    navSale.custAddr2 = so.Sell_to_Address_2;
                    navSale.custCity = so.Sell_to_City;
                    navSale.custState = so.Sell_to_County;
                    navSale.custZipcode = so.Sell_to_County;
                    navSale.custContactNo = so.Sell_to_Contact_No;
                    navSale.orderDate = so.Order_Date.ToString(); ;
                    navSale.shipmentAgent = so.Shipping_Agent_Code;
                    navSale.shipmentService = so.Shipping_Agent_Service_Code;
                    navSale.orderAmt = string.Format("{0:C}", System.Convert.ToDecimal(so.Total_Order_Amount));
                    navSale.payTerms = so.Payment_Terms_Code;
                    navSale.status = so.Status.ToString();
                    navSales.Add(navSale);
                    //foreach (Sales_Order_Line sl in so.SalesLines)
                    //{
                    //    SalesLine navSalesLine = new SalesLine();
                    //    navSalesLine.itemNo = sl.No;
                    //    navSalesLine.itemDesc = sl.Description;
                    //    navSalesLine.Qty = string.Format("{0:C}", System.Convert.ToDecimal(sl.Quantity));
                    //    navSalesLine.lineAmt = string.Format("{0:C}", System.Convert.ToDecimal(sl.Line_Amount));
                    //    navSalesLine.unitPrice = string.Format("{0:C}", System.Convert.ToDecimal(sl.Unit_Price));
                    //    navSalesLine.qtyToShip = string.Format("{0:C}", System.Convert.ToDecimal(sl.Qty_to_Ship));
                    //    navSalesLine.qtyToInvoice = string.Format("{0:C}", System.Convert.ToDecimal(sl.Qty_to_Invoice));
                    //    navSalesLine.shipDate = sl.Shipment_Date.ToString();
                    //    navSalesLine.planShipDate = sl.Planned_Shipment_Date.ToString();
                    //    navSalesLines.Add(navSalesLine);

                    //}


                }

                return navSales;

            }
            catch (Exception)
            {
                
                throw;
            }
            
        }

        public List<SalesHeader> SearchSales(string searchString)
        {

            try
            {
                string baseURL = "http://localhost:7047/DynamicsNAV70/WS/CRONUS USA, Inc./Page/SalesOrder";

                SalesOrder_PortClient salesOrderService = new SalesOrder_PortClient(webServiceHelper.GetNAVBinding(), new EndpointAddress(baseURL));

                salesOrderService.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Delegation;
                salesOrderService.ClientCredentials.Windows.ClientCredential.UserName = "win8user";
                salesOrderService.ClientCredentials.Windows.ClientCredential.Password = "win8win8";
                salesOrderService.ClientCredentials.Windows.ClientCredential.Domain = "WIN8RTM";


                const int fetchsize = 30;

                SalesOrder_Filter filter = new SalesOrder_Filter();
                filter.Field = SalesOrder_Fields.Sell_to_Customer_Name;
                filter.Criteria = "@*" + searchString + "*";

                SalesOrder_Filter[] filters = new SalesOrder_Filter[] { filter };

                Task<ReadMultiple_Result4> _salesResult = salesOrderService.ReadMultipleAsync(filters, null, fetchsize);
                ReadMultiple_Result4 salesResults = _salesResult.Result;

                List<SalesHeader> navSales = new List<SalesHeader>();
                List<SalesLine> navSalesLines = new List<SalesLine>();

                foreach (SalesOrder so in salesResults.ReadMultiple_Result)
                {
                    SalesHeader navSale = new SalesHeader();
                    navSale.orderNo = so.No;
                    navSale.custNo = so.Sell_to_Customer_No;
                    navSale.custName = so.Sell_to_Customer_Name;
                    navSale.custAddr = so.Sell_to_Address;
                    navSale.custAddr2 = so.Sell_to_Address_2;
                    navSale.custCity = so.Sell_to_City;
                    navSale.custState = so.Sell_to_County;
                    navSale.custZipcode = so.Sell_to_County;
                    navSale.custContactNo = so.Sell_to_Contact_No;
                    navSale.orderDate = so.Order_Date.Date.ToString(); ;
                    navSale.shipmentAgent = so.Shipping_Agent_Code;
                    navSale.shipmentService = so.Shipping_Agent_Service_Code;
                    navSale.orderAmt = string.Format("{0:C}", System.Convert.ToDecimal(so.Total_Order_Amount));
                    navSale.payTerms = so.Payment_Terms_Code;
                    navSale.status = so.Status.ToString();
                    navSales.Add(navSale);

                }

                return navSales;
            }
            catch (Exception)
            {
                
                throw;
            }
            
        }
    }
}
