﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml;
using System.ServiceModel;
using NavisionApp.NAVService;
using Windows.Data.Xml.Dom;
using Windows.UI.Notifications;
using Windows.Storage;
using Windows.UI.Xaml.Input;

namespace NavisionApp
{
    
     
    public class TileItem
    {
        public string TileTitle { get; set; }

        public string TileData1 { get; set; }

        public string TileData2 { get; set; }

        public string TileData3 { get; set; }

        public string TileData4 { get; set; }
    }

    public class GetTiles
    {

        WebServiceHelper webServiceHelper = new WebServiceHelper();
        public List<TileItem> LoadTiles()
        {
            try
            {
                string baseURL = "http://localhost:7047/DynamicsNAV70/WS/CRONUS USA, Inc./Codeunit/TileSummary";



                TileSummary_PortClient TileSummaryServices = new TileSummary_PortClient(webServiceHelper.GetNAVBinding(), new EndpointAddress(baseURL));

                TileSummaryServices.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Delegation;
                TileSummaryServices.ClientCredentials.Windows.ClientCredential.UserName = "win8user";
                TileSummaryServices.ClientCredentials.Windows.ClientCredential.Password = "win8win8";
                TileSummaryServices.ClientCredentials.Windows.ClientCredential.Domain = "WIN8RTM";

                string xmlTile = string.Empty;
                GetTileSummary TileSummaryXML = new GetTileSummary();
                Task<GetTileSummary_Result> xmlResult = TileSummaryServices.GetTileSummaryAsync();
                GetTileSummary_Result TileXml = xmlResult.Result;
                xmlTile = TileXml.return_value;
                return ReadXML(xmlTile);
            }
            catch (Exception)
            {
                
                throw;
            }
            

        }


        public List<TileItem> ReadXML(string TileXMLString)
        {
            try
            {
                List<TileItem> TileItems = new List<TileItem>();
                XmlDocument xDoc = new XmlDocument();
                xDoc.LoadXml(TileXMLString);
                XmlNodeList rootList = xDoc.GetElementsByTagName("Summary");
                for (int i = 0; i <= rootList.Count - 1; i++)
                {
                    TileItem ts = new TileItem();
                    ts.TileTitle = rootList[i].ChildNodes.Item(1).InnerText.Trim();
                    ts.TileData1 = rootList[i].ChildNodes.Item(3).InnerText.Trim();
                    ts.TileData2 = rootList[i].ChildNodes.Item(5).InnerText.Trim();
                    ts.TileData3 = rootList[i].ChildNodes.Item(7).InnerText.Trim();
                    ts.TileData4 = rootList[i].ChildNodes.Item(9).InnerText.Trim();
                    TileItems.Add(ts);
                }

                return TileItems;
            }
            catch (Exception)
            {
                
                throw;
            }
            
            
        }


        protected async void UpdateTileFcn(object sender, TappedRoutedEventArgs e)
        {
            // code to update tile here
            try
            {
                string URI = "http://localhost/tiles/apAppTile.xml";

                XmlDocument xmlDoc = await XmlDocument.LoadFromUriAsync(new System.Uri(URI));
                TileNotification tileNotification = new TileNotification(xmlDoc);
                tileNotification.ExpirationTime = DateTimeOffset.Now.AddHours(0.5);
                TileUpdateManager.CreateTileUpdaterForApplication().Update(tileNotification);
            }
            catch (Exception)
            {
                
                throw;
            }

            
        }


        public void ToastNotificationNAV(string Note)
        {
            try
            {
                ToastTemplateType toastTemplate = ToastTemplateType.ToastText04;
                XmlDocument toastXml = ToastNotificationManager.GetTemplateContent(toastTemplate);
                XmlNodeList toastTextElements = toastXml.GetElementsByTagName("text");
                toastTextElements[0].AppendChild(toastXml.CreateTextNode("Receipt Created"));
                IXmlNode toastNode = toastXml.SelectSingleNode("/toast");
                ((XmlElement)toastNode).SetAttribute("duration", "short");
                ToastNotification toast = new ToastNotification(toastXml);
                ToastNotificationManager.CreateToastNotifier().Show(toast);
            }
            catch (Exception)
            {
                
                throw;
            }
            
        }

    }
    
    
    
}
